PROGRAM CONRED63;
{$F+}
{***********************************************************
"CONVERTIDOR 12 PULSOS DOS VIAS CON INDUCTANCIA SERIE Y CARGA R-L"
Autores: JRomero - Arodri
Fecha: 16-02-98

		 La simulacin corresponde a un CONVERTIDOR 12 PULSOS DOS VIAS
		 CON INDUCTANCIA DE LINEA Y COORTOCICUITO DEL SECUNDARIO DEL
		 TRANSFORMADOR Y CARGA R-L

		 y se observarn los siguientes parmetros:

		 * tensin de salida de cada convertidor.
		 * tension de salida total.
		 * corriente de carga.
		 * estado de los tiristores.
**********************************************************}

USES
wincrt,xmatdefs, winGraph,Dibus,FilUSR, UCntrl, Simul4, traxp, variable,
PlotMems, memorias, lib_basi, libep02, libep, libdig01;

CONST w=PI*100;           {frecuencia de red=50 hz}
		periodo=20e-3;      {periodo=2*PI/w}
		Npuntos=1024;       {nmero de puntos de muestreo}
		sexrad=PI/180;      {constante de conversin de sexagesimal a rad}


var
	mem1:Tmemoria;
	R_Carga, L_Carga, L_conmu:NReal; {.Para controlar variables.}
	U, IR_RED, Intensidad, grados:NReal;  {variableS para visualizar en pantalla}
	valor_medio_Ud:NReal;
	enY1:Integer;

{variables de mando que almacenan los valores introducidos por el usuario}
	 Alpha:NReal;
	 inductor:NReal;
	 conmutacion:Boolean;

{----------------------------------------------------------------------}

FUNCTION disparo1(k:integer): boolean;
var  vref:NREAL;
BEGIN
		vref:=-cos(alpha*sexrad);
		disparo1:=(vref<=sin(w*t-2*PI/3 -PI/6 -(k-1)*PI/3)) and
					 (cos(w*t-2*PI/3 -PI/6 -(k-1)*PI/3)>=0);
END;

{----------------------------------------------------------------------}
FUNCTION disparo2(k:integer): boolean;
var  vref:NREAL;
BEGIN
		vref:=-cos(alpha*sexrad);
		disparo2:= (vref<=sin (w*t-2*PI/3 -(k-1)*PI/3)) and
					(cos(w*t-2*PI/3 -(k-1)*PI/3)>=0);

{if (t<0.001) and (k=4)  then  disparo2:=false;}
END;

{----------------------------------------------------------------------}

{*********************************************************
A continuacin los procedimientos Cirt1, Cirt2 y Funcsr de
definicin del circuito.
*********************************************************}

PROCEDURE CIRT1;
BEGIN
	  vg(1, 14,13, 311*SQRT(3));   {R1}
	  vg(2, 12,14, 311*SQRT(3));   {S1}
	  vg(3, 13,15, 311*SQRT(3));   {T1}

	  vg(4, 10,17, 311);   {R2}
	  vg(5, 10,18, 311);   {S2}
	  vg(6, 10,19, 311);   {T2}

	  IF CONMUTACION=FALSE THEN
	  BEGIN
	  R(13,16, L_conmu);
	  R(14,21, L_conmu);
	  R(15,3, L_conmu);
	  R(17,20, L_conmu);
	  R(18,7, L_conmu);
	  R(19,8, L_conmu);
	  END ELSE
			BEGIN
			L(13,16, L_conmu);  {L de linea del 1}
			L(14,21, L_conmu);
			L(15,3,  L_conmu);
			 R(13,16, 1000);
			 R(14,21, 1000);
			 R(15,3,  1000);
			L(17,20, L_conmu);  {L de linea del 2}
			L(18,7,  L_conmu);
			L(19,8,  L_conmu);
			 R(17,20, 1000);
			 R(18,7,  1000);
			 R(19,8,  1000);
			END;

	  R(16,1,  0.01);  {para medir iU del 1}
	  R(21,2,  0.01);  {para medir iV del 1}
	  R(20,6,  0.01);  {para medir iX del 2}

	  R(4,11, R_Carga);           { R PARALELO CON L}
	  L(11,0, L_carga);

	  R(9,5,  1);           { R DE UNION}

END;

{---------------------------------------------------------------------}

PROCEDURE CIRT2;
BEGIN
	  th(1,4,disparo1(1));     {T1}
	  th(5,3,disparo1(2));     {T2}
	  th(2,4,disparo1(3));     {T3}
	  th(5,1,disparo1(4));     {T4}
	  th(3,4,disparo1(5));     {T5}
	  th(5,2,disparo1(6));     {T6}

	  th(6,9,disparo2(1));     {T1}
	  th(0,8,disparo2(2));     {T2}
	  th(7,9,disparo2(3));     {T3}
	  th(0,6,disparo2(4));     {T4}
	  th(8,9,disparo2(5));     {T5}
	  th(0,7,disparo2(6));     {T6}
END;

{---------------------------------------------------------------------}

PROCEDURE FUNCSR(t:NReal);
BEGIN
rf[1]:=sin(w*t);        	 {R1}
rf[2]:=sin(w*t-2*PI/3 ); 	 {S1}
rf[3]:=sin(w*t-4*PI/3 );	    {T1}

rf[4]:=sin(w*t ); 	{R2}
rf[5]:=sin(w*t-2*PI/3 );	{S2}
rf[6]:=sin(w*t-4*PI/3 );	{T2}
END;

{---------------------------------------------------------------------}

{********************************************************
A continuacin los procedimientos de inicio, fin  y Pesca
necesarios para Simeep
*********************************************************}

PROCEDURE INICIO;
BEGIN
nn:=21;			{nmero de nodos del circuito sin incluir 0 (Tierra)}
nindep:=6;		{nmero de fuentes independientes}
tinicial:=0;   {tiempo incial de cada simulacin}
tfinal:=20e-3; {tiempo final de cada simulacin}

{Valores iniciales de variables de estado.
 Estas se definen en el orden en que aparecen las inductancias
 y Capacitancias en Cirt1}

if conmutacion=true then
begin
x0[1]:=-1.093063195;
x0[2]:=-0.046835731277;
x0[3]:=1.1398989263;
x0[4]:=0.00021276838149;
x0[5]:=-1.1347433887;
x0[6]:=1.1345306203;
end;

x0[7]:=1.65;

{valores de precisin de Simeep}
dtmax0:=10e-6;
dtmin:=dtmax0/100;
PasoDivisor:=6;
TmaxTmin:=1e3;

{indicamos a TRAXP los tiempos que debe graficar}
traxp.tinicial:=tinicial;
traxp.tfinal:=tfinal;


{En esta seccin, definimos el nmero de pantallas, y los colores,
 en nmero de grillas inciales, y si tenemos alguna superpocicin
 de seales en una misma ventana}

gridx:=12;	{las divisiones en X son 12}
gridy:=12;	{las diviciones en Y son 8}
subplot(1,2); {matriz de pantallas de 1 por 1}


{definiciones de visualizacin para la pantalla 0 y est asociada al canal 0}
definaY(0,-240,120);
titulo(' (Azul): u_d    (Rojo): i_d      (Amarillo): Salida A     (Marron): Salida B');
xlabel(' SALIDA');
ylabel('100 V/DIV.  ');
linea0;
grid;
superponga(2,0);
superponga(3,0);
superponga(4,0);
superponga(5,0);
superponga(6,0);
superponga(7,0);
superponga(8,0);
superponga(9,0);
superponga(10,0);

superponga(22,0);
superponga(23,0);
superponga(24,0);
superponga(25,0);
superponga(26,0);
superponga(27,0);

 definacolor(0,1);
 definacolor(2,12);
 definacolor(3,14);
 definacolor(4,6);
 definacolor(5,8);
 definacolor(6,8);
 definacolor(7,8);
 definacolor(8,8);
 definacolor(9,8);
 definacolor(10,8);
 definacolor(22,8);
 definacolor(23,8);
 definacolor(24,8);
 definacolor(25,8);
 definacolor(26,8);
 definacolor(27,8);


{definiciones de visualizacin para la pantalla 1 y est asociada al canal 1}
definaY(1,-120,10);
titulo(' Disparo de los semiconductores: (Amarillo): Circuito A   (Marron): Circuito B');
xlabel('30 /DIV');
ylabel('6  5  4 3  2  1  6  5 4  3  2  1');
linea0;
grid;
superponga(11,1);
superponga(12,1);
superponga(13,1);
superponga(14,1);
superponga(15,1);
superponga(16,1);
superponga(17,1);
superponga(18,1);
superponga(19,1);
superponga(20,1);
superponga(21,1);
 definacolor(1,14);
 definacolor(11,14);
 definacolor(12,14);
 definacolor(13,14);
 definacolor(14,14);
 definacolor(15,14);
 definacolor(16,6);
 definacolor(17,6);
 definacolor(18,6);
 definacolor(19,6);
 definacolor(20,6);
 definacolor(21,6);
END;

{---------------------------------------------------------------------}

PROCEDURE PESCA;
var   k, d, enX:integer;
		coseno:NREAL;
BEGIN


grados:=18000*t; {....Para ver en el display el tiempo y los grados.}
if grados>=360 then grados:=grados-360*Int(t/0.02);

iR_RED:=(v[20]-v[6])/(2*0.01)+(V[16]-V[1]-V[21]+V[2])/(0.01*2*sqrt(3));

intensidad:= (v[4]-v[11])/R_Carga;

mem1.tic(t,v[4]);

if conmutacion=true then
begin
			  {Calculo el tiempo de conmutacion Uk }
 coseno:=cos(alpha*PI/180)-w*L_conmu*2*intensidad/ (SQRT(3)*311);
 if (coseno>-0.00001) AND (coseno<0.000001) then coseno:=0.000001;
 coseno:=ABS(coseno);
 U:=ArcTan(SQRT(ABS(1-SQR(coseno)))/coseno);
 if alpha>90 then U:=PI-U;
 u:=u*180/pi;
 U:=ABS(U-alpha);
end
else U:=0.0;


{...Pinto anotaciones sobre las graficas...}
enX:=PUNTOX+25; {paso la ordenada x que pinta la onda a la variable enX por medio de la funcion puntox}

{ANOTAR_EVENTO(GRAD1,GRAD2,GRAD, ENX,       y,y1a,y1b,y2a,y2b,etiqueta)}
{Alpha}ANOTAR_EVENTO(1,30, 30+alpha, grados,enx, 210,207,enY1,207,enY1,CHR(224));

{ANOTAR_EVENTO(GRAD1,GRAD2,GRAD, ENX,       y,y1a,y1b,y2a,y2b,etiqueta)}
{Alpha}ANOTAR_EVENTO(2,30, 30+alpha, grados,enx, 372,250,250,250,250,CHR(224));



{indicar el tiempo de simulacin a el graficador}
traxp.t:=t;
{relacin de seales a graficar con los canales deseados}

{...........grafica 0.........}
trazo(5, 0);
trazo(6, 0);
trazo(7, 0);
trazo(8, 0);
trazo(9, 0);
trazo(10,0);

SetLineStyle(0,0,3);
trazo(2,  (v[4]-V[11])/R_Carga *600);       { i carga   }

trazo(0, v[4]);                    { v salida  }
SetLineStyle(0,0,0);

trazo(3, v[4]-V[5]);               { v salida a}
trazo(4, v[9]);                    { v salida b}
enY1:=PUNTOY+22; {paso la ordenada y que pinta la onda a la variable enY por medio de la funcion puntox}

{...........grafica 1..........}
{graficar: pulsos de disparo de cada tiristor atender los offset utilizados}
if disparo1(1)=true then d:=6 else d:=0; {veo el estado de los tiristores}
  trazo(1,d-10); trazo(1,-10);
if disparo1(2)=true then d:=6 else d:=0;
  trazo(11,d-20); trazo(11,-20);
if disparo1(3)=true then d:=6 else d:=0;
  trazo(12,d-30);trazo(12,-30);
if disparo1(4)=true then d:=6 else d:=0;
  trazo(13,d-40);trazo(13,-40);
if disparo1(5)=true then d:=6 else d:=0;
  trazo(14,d-50);trazo(14,-50);
if disparo1(6)=true then d:=6 else d:=0;
  trazo(15,d-60);trazo(15,-60);

if disparo2(1)=true then d:=6 else d:=0; {veo el estado de los tiristores}
  trazo(16,d-70); trazo(16,-70);
if disparo2(2)=true then d:=6 else d:=0;
  trazo(17,d-80); trazo(17,-80);
if disparo2(3)=true then d:=6 else d:=0;
  trazo(18,d-90);trazo(18,-90);
if disparo2(4)=true then d:=6 else d:=0;
  trazo(19,d-100);trazo(19,-100);
if disparo2(5)=true then d:=6 else d:=0;
  trazo(20,d-110);trazo(20,-110);
if disparo2(6)=true then d:=6 else d:=0;
  trazo(21,d-120);trazo(21,-120);




	{borrado de la pantalla despus de cada simulacin}
	if t >= tfinal then
	begin
			for k:= 0 to 21 do
		begin
		borrecanal(k,0);
		desligue(k);
		borde;
			grid;
			linea0;

		end;

		mem1.fft;                           {valor medio de Ud }
		valor_medio_Ud:=mem1.valormedio;
		mem1.retrocesobarrido(tfinal-tinicial);

		t:= t-tfinal+tinicial;
	end;
END;

{---------------------------------------------------------------------}

PROCEDURE FIN;
BEGIN
HALT;
END;

{---------------------------------------------------------------------}

PROCEDURE INICIALIZACION_PARAMETROS;
BEGIN
{valores iniciales de los controles}
conmutacion:=TRUE;
valor_medio_ud:=874.4;
END;


{---------------------------------------------------------------------}


{******************************PRINCIPAL*******************************}
BEGIN
INICIALIZACION_PARAMETROS;

{Indicamos a Simeep donde estn las funciones que preparamos}
FilUSR.Cirt1:=Cirt1;
FilUSR.Cirt2:=Cirt2;
FilUSR.FuncsR:=FuncsR;
FilUSR.Inicio:=Inicio;
FilUSR.Pesca:=Pesca;
FilUSR.Fin:=Fin;

{Pantalla de controles}
UCntrl.init;

mem1:= TMemoria.Create_init(20e-3/1024,1024,0,0);
{------------------PARA VISUALIZAR TEXTO EN LA SIMULACION--------------}

UCntrl.insert(new(PCtrlVerTexto,init
(    0,   '    CONVERTIDOR ',
			 '    EN CONEXION',
			 '12 PULSOS  DOS VIAS ')));

UCntrl.insert(new(PCtrlVerTexto,init
(    4,   '    ',
			 '        CARGA',
			 '        R - L ')));

UCntrl.insert(new(PCtrlVerTexto,init
(    7,   '    ',
			 '     ',
			 'INDUC.SERIE Y DISPARO ')));


{---------------PARA CONTROLAR VARIABLES EN LA SIMULACION--------------}

if conmutacion=true then
UCntrl.insert(new(PCtrlBotonVar,Init
{renglon, nombre,  unidad, decimales, min, max,   def, inc,    var}
(    8, ' L_CONMU',  'mH'    ,0,       1,  100,  30, 10, L_CONMU)))
else l_conmu:=0;


UCntrl.insert(new(PCtrlBotonVar,Init
{renglon, nombre,  unidad, decimales, min, max,   def,   inc,    var}
(    5, ' R_Carga',  'Oh'    ,0,       525,   1000,   525,  50,  R_Carga)));


UCntrl.insert(new(PCtrlBotonVar,Init
{renglon, nombre,  unidad, decimales, min, max,   def,   inc,    var}
(    6, ' L_Carga',  'mH'    ,0,       1,   1000,   500,  50,  L_Carga)));


UCntrl.insert(new(PCtrlBotonVar,Init
{renglon, nombre,  unidad, decimales, min, max,   def, inc,    var}
(    9, '  Alpha',  ''    ,0,       0,   90,    30,  2,   alpha)));

{-----------------PARA VER VARIABLES EN LA SIMULACION------------------}

UCntrl.insertdisplay(new(PCtrlVer2Var,init
{ renglon,  nombre1,  uni1, deci1,  var1 , nombre2,  uni2, deci2, var2}
(    1,    'Tiempo',   'Sg',   3  ,  t ,  'Grados',  '',    0 ,Grados)));


UCntrl.insertdisplay(new(PCtrlVer2Var,init
{ renglon, nombre1, uni1, deci1,  var1 , nombre2, uni2, deci2, var2}
(    2, 'u',  '',      1  ,  U , 'i_d' ,  'A',   1 , intensidad)));



UCntrl.insertdisplay(new(PCtrlVer2Var,init
{ renglon, nombre1, uni1, deci1,  var1 , nombre2, uni2, deci2, var2}
(    3, 'v_d med.',  'V',     1  , valor_medio_ud , 'v_d inst.', 'V',  1, v[4])));


PASEO;
END.
