{+doc
+NOMBRE: MatEnt
+CREACION: 6.1.1994
+AUTORES: rch @floresta
+REGISTRO:
+TIPO: Unidad Pascal.
+PROPOSITO: definicion del objeto MatEiz de enteros.
+PROYECTO: rchlib

+REVISION:
+AUTOR:
+DESCRIPCION:
  Todas las tareas implementadas en esta biblioteca, tienen como
filosofia que los datos estan bien definidos, y para mejorar la
velocidad no verifican la coherencia. Tampoco se encargan de
inicializar MatEices. Supongamos que vamos a multiplicar las
MatEices A y B , y queremos el resultado en C, la sentecia es
C.MultM(A,B); pero se debe cuidar que los rangos sean los adecuados
y se debe inicializar C antes del llamado a MultMatE.
  Las unicas tareas que inicializan  datos del objeto son las de
lectura. Ej: a.readM; inicialliza a.

-doc}

unit MatEnt;

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

interface
uses
  classes, xMatDefs, ComPol;

type
  TVectE = class
    n: integer;
    pv: TDAOfNInt;
    constructor Create_Init(ne: integer);
    //      constructor Create_Ventana( ne: integer; var x );
    constructor Create_Load(var S: TStream);
    procedure Store(var S: TStream);
    procedure Igual(x: TVectE);
    function e(k: integer): NEntero;
    procedure pon_e(k: integer; x: NEntero);
    procedure acum_e(k: integer; x: NEntero);
    procedure IntercambiarElementos( k1, k2: integer );
    function PEV(var y: TVectE): NEntero;
    function PEVRFLX(var y: TVectE): NEntero;
    procedure PorEntero(r: NEntero);
    procedure sum(var y: TVectE);
    procedure sumRPV(r: NEntero; var x: TVectE);
    function ne2: NEntero; {norma euclideana al cuadrado }
    function normEuclid: NReal;
    function normMaxAbs: NEntero;
    function normSumAbs: NEntero;
    procedure Copy(var x: TVectE);
    procedure Ceros; virtual;
    procedure MinMax(var kMin, kMax: integer; var Min, Max: NEntero);
    procedure Print; virtual;
    procedure Free; virtual;
  end;


type
  TMatE = class
    nf, nc: integer;
    pm: array of TVectE;

    constructor Create_Init(filas, columnas: integer);
    constructor Create_Load(var S: TStream);
    procedure Store(var S: TStream);
    constructor Create_ReadM; (* a debe estar sin inicializar *)
    procedure Igual(x: TMatE);
    function e(k, j: integer): NEntero;
    procedure pon_e(k, j: integer; x: NEntero);
    procedure acum_e(k, j: integer; x: NEntero);
    procedure IntercambieFilas(k1, k2: integer);
    procedure Mult(a, b: TMatE);
    procedure WriteM;
    function Traza: NEntero;
    function Deter: NEntero;
    function Escaler(var i: TMatE): NEntero;
    procedure CopyColVect(var Y: TVectE; J: integer);
    function inv: boolean;
    procedure Ceros; virtual;
    procedure Free; virtual;
  end;



implementation


constructor TMatE.Create_Init(filas, columnas: integer);
var
  k: integer;
begin
  inherited Create;
  setlength(pm, filas + 1); // la fila 1 la desperdicio
  nf := filas;
  nc := columnas;
  for k := 1 to filas do
    pm[k] := TVectE.Create_Init(columnas);
end;


constructor TMatE.Create_Load(var S: TStream);
var
  k: integer;
begin
  inherited Create;
  S.Read(nf, sizeOf(nf));
  S.Read(nc, sizeOf(nc));
  setlength(pm, nf + 1);
  for k := 1 to nf do
    pm[k] := TVectE.Create_Load(s);
end;

procedure TMatE.Store(var s: TStream);
var
  k: integer;
begin
  S.Write(nf, sizeOf(nf));
  S.Write(nc, sizeOf(nc));
  for k := 1 to nf do
    pm[k].Store(s);
end;



function TMatE.e;
begin
  e := pm[k].e(j);
end;

procedure TMatE.pon_e(k, j: integer; x: NEntero);
begin
  pm[k].pon_e(j, x);
end;

procedure TMatE.acum_e(k, j: integer; x: NEntero);
begin
  pm[k].acum_e(j, x);
end;




constructor TVectE.Create_Init(ne: integer);
begin
  inherited Create;
  n := ne;
  setlength(pv, ne + 1);
end;

constructor TVectE.Create_Load(var S: TStream);
begin
  inherited Create;
  S.Read(n, sizeOf(n));
  setlength(pv, n + 1);
  S.Read(pv[1], n * SizeOf(integer));
end;


procedure TVectE.Store(var S: TStream);
begin
  S.Write(n, sizeOf(n));
  S.Write(pv[1], n * SizeOf(NReal));
end;


procedure TVectE.Free;
begin
  setlength(pv, 0);
  inherited Free;
end;


procedure TVectE.Print;
var
  k: integer;
begin
  writeln(' TVectE.print.inicio');

  for k := 1 to n do
    writeln(' N: ', k: 6, ' : ', e(k): 12);
  writeln(' TVectE.print.fin');

end;

(*
constructor TVectE.Ventana( ne: integer; var x );
begin
  TVect.Ventana( ne, SizeOf(NEntero), x);
end;
  *)

function TVectE.e(k: integer): NEntero;
begin
  e := pv[k];
end;


procedure TVectE.Igual(x: TVectE);
var
  k: integer;
begin
  for k := 1 to n do
    pv[k] := x.pv[k];

end;


procedure TVectE.pon_e(k: integer; x: NEntero);
begin
  pv[k] := x;
end;

procedure TVectE.acum_e(k: integer; x: NEntero);
begin
  pv[k] := pv[k] + x;
end;

procedure TVectE.IntercambiarElementos( k1, k2: integer );
var
   x: integer;
begin
  x:= e( k1 );
  pon_e( k1, e(k2));
  pon_e( k2, x );
end;


procedure TMatE.Ceros;
var
  k: integer;
begin
  for k := 1 to nc do
    pm[k].Ceros;

end;


procedure TVectE.Ceros;
var
  k: integer;
begin
  for k := 1 to n do
    pv[k] := 0;
end;


procedure TVectE.MinMax(var kMin, kMax: integer; var Min, Max: NEntero);
var
  k: integer;
begin
  Min := pv[1];
  kMin := 1;
  Max := pv[1];
  kMax := 1;
  for k := 1 to n do
  begin
    if pv[k] < min then
    begin
      Min := pv[k];
      kMin := k;
    end
    else
    if pv[k] > max then
    begin
      Max := pv[k];
      kMax := k;
    end;
  end;
end;


function TVectE.PEV(var y: TVectE): NEntero;
var
  k: integer;
  temp: NEntero;
begin
  temp := 0;
  for k := 1 to n do
    temp := temp + pv[k] * y.pv[k];
  Result := temp;
end;  (* PEV *)


function TVectE.PEVRFLX(var y: TVectE): NEntero;
var
  k: integer;
  temp: NEntero;
begin
  temp := 0;
  for k := 1 to n do
    temp := temp + pv[k] * y.pv[n - k + 1];
  Result := temp;
end;  (* PEVRFLX *)



procedure TVectE.Copy(var x: TVectE);
var
  k: integer;
begin
  for k := 1 to n do
    pv[k] := x.pv[k];
end;


procedure TVectE.sum(var y: TVectE);
var
  k: integer;
begin
  for k := 1 to n do
    pv[k] := pv[k] + y.pv[k];
end;

procedure TVectE.sumRPV(r: NEntero; var x: TVectE);
var
  k: integer;
begin
  for k := 1 to n do
    pv[k] := pv[k] + r * x.pv[k];
end;


procedure TVectE.PorEntero(r: NEntero);
var
  k: integer;
begin
  for k := 1 to n do
    pv[k] := pv[k] * r;
end;

function TVectE.ne2: NEntero; {norma euclideana al cuadrado }
var
  k: integer;
  acum: NEntero;
begin
  acum := 0;
  for k := 1 to n do
    acum := acum + SQR(pv[k]);
  ne2 := acum;
end;

function TVectE.normEuclid: NReal;
begin
  normEuclid := sqrt(ne2);
end;

function TVectE.normMaxAbs: NEntero;
var
  k: integer;
  maxA: NEntero;
begin
  maxA := 0;
  for k := 1 to n do
    if ABS(pv[k]) > maxA then
      maxA := Abs(pv[k]);
  normMaxAbs := maxA;
end;

function TVectE.normSumAbs: NEntero;
var
  k: integer;
  acum: NEntero;
begin
  acum := 0;
  for k := 1 to n do
    acum := acum + ABS(pv[k]);
  normSumAbs := acum;
end;

procedure TMatE.WriteM;
var
  k, J: integer;
begin
  writeln;
  writeln('---------------------------------------');
  for k := 1 to nf do
  begin
    Write('fila', k: 3, '):');
    for j := 1 to nc do
      Write(e(k, j): 12);
    writeln;
  end;
end;


procedure TMatE.Free;
var
  k: integer;
begin
  for k := 1 to nf do
    pm[k].Free;
  setlength(pm, 0);
  inherited Free;
end;


constructor TMatE.Create_ReadM; (* a debe estar sin inicializar *)
var
  k, J: integer;
  m: integer;
begin

  writeln;
  writeln('---------------------------------------');
  Write('numero de filas=?');
  readln(k);
  Write('numero de columnas=?');
  readln(j);
  Create_init(k, j);
  for k := 1 to nf do
  begin
    Write('fila', k: 3, '):?');
    for j := 1 to nc do
    begin
      Read(m);
      pon_e(k, j, m);
    end;
    writeln;
  end;
end;

procedure TMatE.IntercambieFilas(k1, k2: integer);
var
  t: TVectE;
begin
  t := pm[k1];
  pm[k1] := pm[k2];
  pm[k2] := t;
end;


procedure Combinar_E(Eliminada, Eliminador: TVectE; Col1, Col2: integer;
  m1, m2: NEntero);
var
  j: integer;
begin
  for j := Col1 to Col2 do
    Eliminada.pon_e(j, Eliminada.e(j) * m1 + Eliminador.e(j) * m2);
end;

function TMatE.Escaler(var i: TMatE): NEntero;
var
  k, p, j: integer;
  det, m, mc1: NEntero;
  ms: NEntero;

begin { Escaler }

  p := 1;
  det := 1;

  while p < nf do { ESCA 1 }
  begin
    m := abs(e(p, p));
    j := p;
    for k := p + 1 to nf do
    begin
      ms := abs(e(k, p));
      if ms > m then
      begin
        m := ms;
        j := k;
      end;
    end;
    if p <> j then
    begin
      IntercambieFilas(p, j);
      i.IntercambieFilas(p, j);
      det := -det;
    end;
    if m = 0 then
    begin
      det := 0;
      p := nf;
    end
    else{eliminacion}
    begin
      mc1 := e(p, p);
      det := det * mc1;
      for k := p + 1 to nf do
      begin
        m := -e(k, p);
        Combinar_E(pm[k], pm[p], p + 1, nc, mc1, m);
        Combinar_E(i.pm[k], i.pm[p], 1, i.nc, mc1, m);
      end;
    end; { Eliminacin }
    p := p + 1;
  end; { Esca 1 }

  det := det * e(nf, nf);

  if det <> 0 then {Esca 2 }
  begin
    for p := nf downto 2 do
    begin
      m := e(p, p);
      for k := p - 1 downto 1 do
      begin
        mc1 := -e(k, p);
        Combinar_E(i.pm[k], i.pm[p], 1, i.nc, mc1, m);
      end;
    end;
  end; { Esca 2 }
  Escaler := det;
end; {deter}


procedure TMatE.CopyColVect(var Y: TVectE; J: Integer);
var
  k: integer;
begin
  for k := 1 to nf do
    y.pon_e(k, e(k, j));
end;  (* CopyColVect *)




function TMatE.Traza: NEntero;
var
  k: integer;
  temp: NEntero;

begin
  temp := e(1, 1);
  for k := 2 to nc do
    temp := temp + e(k, k);
  Result := temp;
end; (* Traza *)

procedure TMatE.Igual(x: TMatE);
var
  k: integer;
begin
  for k := 1 to nf do
    pm[k].Igual(x.pm[k]);
end;


procedure TMatE.Mult(a, b: TMatE);
var
  k, j: integer;
  v: TVectE;
  mtemp: TMatE;

begin
  v := TVectE.Create_init(b.nf);
  mtemp := TMatE.Create_init(a.nf, a.nc);
  mtemp.igual(a);

  for j := 1 to b.nc do
  begin
    b.CopyColVect(v, j);
    for k := 1 to A.nf do
      pon_e(k, j, v.PEV(mtemp.pm[j]));
  end;
  mtemp.Free;
  v.Free;
end;  (* MultTMatE *)



function TMatE.deter: NEntero;
var
  temp1, temp2: TMatE;
begin
  temp1 := TMatE.Create_init(nf, nc);
  temp1.igual(Self);
  temp2 := TMatE.Create_init(nf, 0);
  deter := temp1.escaler(temp2);
  temp2.Free;
  temp1.Free;
end;




function TMatE.inv: boolean;
var
  temp: TMatE;
  k, j: integer;
  aux: NReal;
begin
  temp := TMatE.Create_init(nf, nc);
  for k := 1 to nf do
    for j := 1 to nc do
      if k = j then
        temp.pon_e(k, j, 1)
      else
        temp.pon_e(k, j, 0);

  aux := Self.escaler(temp);
  Self.igual(temp);
  temp.Free;
  Inv := not EsCero(aux);
end;

begin
(*
writeln('Unidad MatE INSTALADA / RCH-90');
*)
end.
